$	batch = "''f$mode()'" .eqs. "BATCH"
$	if .not. batch then $goto skipshow
$		write sys$output "P1 = ''p1'"
$		write sys$output "P2 = ''P2'"
$		write sys$output "P3 = ''P3'"
$		write sys$output "P4 = ''P4'"
$		write sys$output "P5 = ''P5'"
$		write sys$output "P6 = ''P6'"
$skipshow:
$	ver = 'f$verify(0)' .or. batch
$!
$!	COPYTREES.COM
$!
$!	Author:	J. L. BINGHAM
$!		ManTech International
$!		2320 Mill Road
$!		Alexandria, VA 22314
$!		(703) 838-5600
$!
$!	Modified by:
$!		Dave Leonard
$!		Advanced Data Management
$!		15-17 Main Street
$!		Kingston, NJ  08528
$!		(609)-799-4600
$!
$!	This command procedure is designed to make the copying of directory
$!  trees containing VAX Systems SIG Symposia tapes easy and consistent.
$!  A small file suitable for a label is produced and printed.
$!
$!	The command procedure assumes that the [VAX000] and [VAX000.INDEX]
$!  directories exist and copies them to every tape made.  It also assumes
$!  that the symposia tapes are hanging from directories named [VAX79A],
$!  [VAX79B], ...
$!
$!	When the procedure is being run on my system (ST_BIN translates to
$!  MILLRD::) it puts my name and phone number in MSG and prints the label
$!  on a printer set to forms=5.  On another system it will leave the print
$!  command alone and will use the MSG defined after the label NOTJOE:.  This
$!  provides a place for you to put your name and telephone number.  (You may
$!  want to change the logic instead so you can pass the command procedure
$!  intact without having the next person print labels saying you made the
$!  tape.)
$!
$!	Required information may be passed as parameters or entered in
$!  response to prompts.  Parameters are defined as follows:
$!
$!	P1 -- Tape drive name, e.g. MTA0:
$!	P2 -- Name of the first directory tree to be copied, not including [VAX000].
$!		e.g. VAX79B. (Note:  "VAX7" would start at VAX79A)
$!	P3 -- Name of the last directory tree to be copied,
$!		(may also be truncated, "VAX" will include the
$!		last directory starting VAX)
$!	P4 -- T, Y or 1 will cause a listing of the tape to be
$!		generated.
$!	P5 -- A name to be used for that file.  (A place to put the
$!		name of the intended recipient of the tape if desired.)
$!	P6 -- T, Y or 1 will cause the above listing to be printed.
$!
$!	The following command will copy VAX000 and the fall 1979 through
$!  the fall 1980 tapes with a backup listing being generated but not printed.
$!  The listing will be [VAX000.TEMP]NEXTNODE.LIS.
$!  SUBMIT COPYTREES/PAR=(MTA0:,VAX79B,VAX80B,Y,NEXTNODE,N)
$!
$	set default [vax000]
$	unloadsw = ""
$	form = "/queue=''f$logical("special_forms_printer")'"
$	if f$mode() .eqs. "INTERACTIVE" then -
	inquire msg "Enter your name and phone number for label"
$	goto start
$restart:
$	write sys$output "Error allocating ''P1'"
$	p1 = ""
$start:
$	if p1 .eqs. "" then inquire p1 "Enter name for tape drive, e.g. MTA1"
$	p1 = f$extract(0,4,p1)
$	if .not. batch then on warning then goto restart
$	allocate 'p1' tape
$	if p2 .eqs. "" then inquire p2 "Enter the name of the first tree to be copied, not counting [VAX000]"
$	if p3 .eqs. "" then inquire p3 "Enter the name of the last tree to be copied"
$	if p3 .eqs. "" then p3 = p2
$	if .not. batch .and. p4 .eqs. "" then inquire/nopunc p4 "Create a listing of the save-sets? "
$	if .not. batch .and. p5 .eqs. "" then inquire p5 -
"Enter a name for the listing.  Default is ''P1'"
$		if p5 .eqs. "" then $p5 = p1
$	if .not. batch .and. p6 .eqs. "" then inquire/nopunc p6 "Print the save-set listing? "
$	on warning then goto error
$	on control_y then goto error
$	time = f$extract(0,17,f$time())
$	if batch then request/reply "Please mount a tape on ''P1' with write ring installed."
$	if .not. batch then inquire ok "Mount a tape on ''P1' and enter <CR>"
$	open/write label [.TEMP]'P1'.LBL
$	write label "           VAX Systems SIG Tape Copy Project"
$	write label ""
$	write label "Tape is in VAX DCL BACKUP format with 1600 bpi density."
$	write label "See [VAX000]0README.1ST."
$	write label "Tape produced by: ''MSG'"
$	write label "This tape contains:                     ", time
$	write label "  root directory     save-set name      approx blocks"
$	directory/out=[.temp]'p1'.tmp/nohead/notrail [000000]vax*.dir
$	open/read dir [.temp]'p1'.tmp
$	set verify
$	initialize/density=1600 'P1' vaxsig
$	mount/foreign/density=1600 tape
$	show time
$	backup/interchange [vax000],[vax000.index] tape:vax000
$	dummy = 'f$verify(ver)
$	@treesize [vax000] [vax000.index]
$	write label "  [VAX000]           VAX000            ", blocks
$loop:
$	read/end_of_file=exit dir line
$	left = f$locate("]",line) + 1
$	len = f$locate(".DIR;1",line) - left
$	found = f$extract(left,len,line)
$	if found .lts. p2 then goto loop
$	if found .gts. p3 then goto exit
$	show time
$	set verify
$	backup/norewind/interchange ['found'...] tape:'found'
$	dummy = 'f$verify(ver)
$	@TREESIZE ['FOUND'...]
$	write label "  [''FOUND']           ''FOUND'          ", blocks
$	goto loop
$error:
$	unloadsw = "/nounload"
$	if batch then request "******ERROR MAKING DECUS TAPE******"
$	if .not. batch then write sys$output "******COPY INCOMPLETE******"
$	close label
$	goto exit2
$exit:
$	time = f$time()
$	dummy = f$verify(0)
$	write label "''F$EXTRACT(0,11,TIME)'                          ''F$EXTRACT(11,12,TIME)'"
$	close label
$	write sys$output "BE SURE TO PASS THE FOLLOWING INFORMATION TO THE USER OF THIS TAPE"
$	type [.temp]'p1'.lbl
$	write sys$output "LABEL INFORMATION WILL ALSO BE PRINTED"
$	print'form' [.temp]'p1'.lbl
$	if .not. p4 then goto exit2
$		open/read label [.temp]'p1'.lbl
$		read label line
$		read label line
$		read label line
$		read label line
$		read label line
$		read label line
$		read label line
$readloop:
$		read/end_of_file=nomoresets label line
$		start = f$locate(" VAX",line) + 1
$		if start .eq. f$length(line)+1 then goto nomoresets
$		backup/list=[.temp]'p1't tape:'f$extract(start,13,line)'
$		append/new [.temp]'p1't.lis [.temp]'p5'.lis
$		goto readloop
$nomoresets:
$	close label
$	delete [.temp]'p1'.lbl.*
$	if p6 then $print [.temp]'p5'
$	delete [.temp]'p1't.lis.*
$exit2:
$	on error then continue
$	on control_y then continue
$	dismount'unloadsw' 'p1'
$	deallocate 'p1'
$	close dir
$	delete [.temp]'p1'.tmp.*
$	if batch then $assign nl: sys$print
$	ver = f$verify(ver)
$!
$!	End of COPYTREES.COM
$!
